/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 1 "tinybas.y"

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

/* Definitions */
#define ID_STRLEN	256				/* ID string length */
#define LINE_LEN	1000			/* line string length */
#define ID_MAX	 	1000			/* id max */
#define VAR_MAX	 	1000			/* var max */
#define LBL_MAX	 	1000			/* label max */
#define LINE_MAX	1000			/* line max */
#define NODE_SIZE	1000			/* node max */
#define IF_MAX		1000			/* if max */
#define FOR_MAX		1000			/* for max */
#define val(x)	    (node[x].left)
#define YYSTYPE int

/* Variables */
typedef struct node { int op; int left,right; } NODE;
NODE node[NODE_SIZE];
int nodeptr , error_flag=0;
int cur_ln,prv_ln=0 , rdln=0 , line_acs=0 , line_total=0 , id_total=0;
int var_total=0 , array_total=0 , lbl_acs=0 , lbl_total=0 , if_total=0 , for_total=0;
int line_num[LINE_MAX], line_flag[LINE_MAX], line_access[LINE_MAX][1];
int lbl_flag[LBL_MAX],lbl_access[LBL_MAX][2];
int if_stackp,if_stackp2,if_stack[IF_MAX],if_stack2[IF_MAX];
int for_stackp,for_stack[FOR_MAX],for_var[FOR_MAX], for_line[FOR_MAX];
char remark[LINE_LEN], inlines[LINE_LEN], prt_str[LINE_LEN];
char identifier[ID_MAX][ID_STRLEN], var_id[VAR_MAX][ID_STRLEN];
char array_id[VAR_MAX][ID_STRLEN], lbl_id[LBL_MAX][ID_STRLEN];
FILE *infile, *outfile;

/* Function prototypes */
int mknd(int op, int l, int r);
void initnode();
void gencode(int p);
void rem();
void inline_();
void printx();
void mk_end();
void mk_line(int p);
void mk_goto(int p);
void mk_goto_lbl(int p);
void mk_if_then(int p);
void mk_else();
void mk_endif();
void mk_for(int f1,int f2,int f3,int f4);
void mk_next(int p);
int mk_var(int p);
int mk_array(int p,int size);
int mk_lbl(int p);
int ref_line(int line);
int create_line(int line);
int line_exist(int line);
int create_id(char *id_name);
int id_exist(char *id_name);
int create_var(int id_nm);
int create_array(int id_nm);
int var_exist(int id_nm);
int array_exist(int id_nm);
int create_lbl(int id_nm);
int lbl_exist(int id_nm);
int print(char *fmt, ...);
int my_stricmp(char *s1,char *s2);

/*********************************************************
**		compiler main
**********************************************************/
int main(int argc, char *argv[] )
{
	char in_name[64],out_name[64];
	int i;
	char c;
	in_name[0]='\0'; out_name[0]='\0';
	
	printf("Tiny Basic Compiler Ver 0.1  (c)2012 E.Kako\n\n");
	if	(argc!=2) {
		printf("Usage: tinybas source[.bas]\n"); return 0;
	}
	
	if (strchr(argv[1],'.')==0) {
		strcpy(in_name,argv[1]); strcat(in_name,".bas");
		strcpy(out_name,argv[1]); strcat(out_name,".il");
	} else {
		strcpy(in_name,argv[1]);
		i=0; do { c=out_name[i]=in_name[i]; i++; } while (c!='.');
		out_name[i-1]='\0';
		strcat(out_name,".il");
	}
	if ( (infile=fopen(in_name,"r"))==NULL ) {
		printf("file cannot open.\n"); exit(1);
	}
	if ( (outfile=fopen(out_name,"w"))==NULL ) {
		printf("file cannot create.\n"); exit(1);
	}
	printf("Source File: %s\n",in_name);
	printf("Object File: %s\n",out_name);
	print("//============================================================\n");
	print("//\tCompiler: Tiny Basic Compiler Ver 0.1\n");
	print("//\tSource: %s\n",in_name);
	print("//\tObject: %s\n",out_name);
	print("//============================================================\n");
	print("\n");
	print(".assembly extern mscorlib { }\n");
	print(".assembly basic_program { }\n");
	print(".method static void main() {\n");
	print("\t.entrypoint\n");
	print("\t.maxstack 16\n");
	print("\t//------------------------------------\n");
	for_stackp=0;
	initnode();
	yyparse();
	print("\n");
	print("\t//------------------------------------\n");
	print("_END:\n");
	print("\tret\n");
	print("}\n");
	fclose(infile);
	fclose(outfile);
	return error_flag;
}
int print(char *fmt, ...) /* output */
{
	int r;
	va_list argptr;
	
	va_start(argptr, fmt);
	vfprintf(outfile, fmt, argptr);
	va_end(argptr);
	return 0;
}


/* Line 268 of yacc.c  */
#line 208 "tinybas.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ID = 258,
     NUMBER = 259,
     REM = 260,
     LINENUMBER = 261,
     LABEL = 262,
     INLINE = 263,
     INLINE_PUSH = 264,
     INLINE_POP = 265,
     GOTO = 266,
     GOLBL = 267,
     IF = 268,
     THEN = 269,
     ELSE = 270,
     ENDIF = 271,
     FOR = 272,
     TO = 273,
     STEP = 274,
     NEXT = 275,
     END = 276,
     DIM = 277,
     INPUT = 278,
     PRINT = 279,
     PRINTX = 280,
     MOD = 281,
     XOR = 282,
     OR = 283,
     AND = 284,
     NEG = 285,
     UNARYMINUS = 286,
     NOT = 287,
     UNARYNEGAT = 288
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 283 "tinybas.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   264

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  45
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  30
/* YYNRULES -- Number of rules.  */
#define YYNRULES  75
/* YYNRULES -- Number of states.  */
#define YYNSTATES  130

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   288

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      28,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      26,    27,    34,    32,     2,    33,     2,    35,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    44,     2,
      30,    29,    31,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    36,    37,    38,    39,    40,    41,    42,    43
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint8 yyprhs[] =
{
       0,     0,     3,     4,     7,    11,    15,    18,    20,    22,
      24,    26,    29,    33,    35,    37,    40,    42,    44,    46,
      49,    51,    54,    58,    61,    63,    65,    67,    69,    71,
      73,    75,    77,    79,    81,    83,    87,    91,    96,    99,
     102,   106,   110,   112,   116,   119,   121,   128,   137,   140,
     142,   145,   148,   151,   154,   157,   159,   161,   167,   172,
     176,   180,   184,   188,   192,   196,   200,   204,   208,   212,
     216,   220,   222,   224,   226,   229
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      46,     0,    -1,    -1,    46,    28,    -1,    46,    47,    28,
      -1,    46,     1,    28,    -1,    49,    48,    -1,    53,    -1,
      52,    -1,    51,    -1,    50,    -1,    50,    53,    -1,    50,
      44,    54,    -1,    54,    -1,     4,    -1,    34,     3,    -1,
      25,    -1,     8,    -1,     5,    -1,    44,     5,    -1,    55,
      -1,    55,    53,    -1,    56,    44,    55,    -1,    60,    61,
      -1,    56,    -1,    57,    -1,    59,    -1,    63,    -1,    64,
      -1,    67,    -1,    68,    -1,    65,    -1,    66,    -1,    72,
      -1,    21,    -1,    71,    29,    74,    -1,    58,    29,    74,
      -1,     3,    26,    74,    27,    -1,    11,    70,    -1,    11,
      69,    -1,    13,    74,    14,    -1,    56,    44,    61,    -1,
      56,    -1,    56,    62,    61,    -1,    60,    61,    -1,    15,
      -1,    17,    71,    29,    74,    18,    74,    -1,    17,    71,
      29,    74,    18,    74,    19,    74,    -1,    20,    71,    -1,
      20,    -1,    24,    74,    -1,    23,    71,    -1,     9,    74,
      -1,    10,    71,    -1,    34,     3,    -1,     4,    -1,     3,
      -1,    22,     3,    26,     4,    27,    -1,     3,    26,    74,
      27,    -1,    74,    29,    74,    -1,    74,    31,    74,    -1,
      74,    30,    74,    -1,    74,    32,    74,    -1,    74,    33,
      74,    -1,    74,    34,    74,    -1,    74,    35,    74,    -1,
      74,    36,    74,    -1,    74,    39,    74,    -1,    74,    38,
      74,    -1,    74,    37,    74,    -1,    26,    74,    27,    -1,
      71,    -1,    73,    -1,    70,    -1,    33,    74,    -1,    42,
      74,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   153,   153,   154,   155,   156,   158,   160,   161,   162,
     163,   164,   165,   166,   168,   170,   172,   174,   176,   177,
     179,   180,   182,   183,   184,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   197,   198,   200,   202,   203,
     205,   207,   208,   209,   210,   212,   214,   216,   219,   220,
     222,   224,   226,   228,   230,   232,   234,   236,   239,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ID", "NUMBER", "REM", "LINENUMBER",
  "LABEL", "INLINE", "INLINE_PUSH", "INLINE_POP", "GOTO", "GOLBL", "IF",
  "THEN", "ELSE", "ENDIF", "FOR", "TO", "STEP", "NEXT", "END", "DIM",
  "INPUT", "PRINT", "PRINTX", "'('", "')'", "'\\n'", "'='", "'<'", "'>'",
  "'+'", "'-'", "'*'", "'/'", "MOD", "XOR", "OR", "AND", "NEG",
  "UNARYMINUS", "NOT", "UNARYNEGAT", "':'", "$accept", "line", "line0",
  "line1", "linenum", "def_lbl", "printx", "inline", "remark", "stat0",
  "states", "state", "let", "larray", "go", "ifbegin", "ifsts", "else",
  "for", "next", "print", "input", "push", "pop", "label", "const", "var",
  "dim", "array", "expr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    40,    41,    10,    61,
      60,    62,    43,    45,    42,    47,   281,   282,   283,   284,
     285,   286,   287,   288,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    45,    46,    46,    46,    46,    47,    48,    48,    48,
      48,    48,    48,    48,    49,    50,    51,    52,    53,    53,
      54,    54,    55,    55,    55,    56,    56,    56,    56,    56,
      56,    56,    56,    56,    56,    57,    57,    58,    59,    59,
      60,    61,    61,    61,    61,    62,    63,    63,    64,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     3,     3,     2,     1,     1,     1,
       1,     2,     3,     1,     1,     2,     1,     1,     1,     2,
       1,     2,     3,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     4,     2,     2,
       3,     3,     1,     3,     2,     1,     6,     8,     2,     1,
       2,     2,     2,     2,     2,     1,     1,     5,     4,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     1,     1,     1,     2,     2
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     1,     0,    14,     3,     0,     0,     5,     4,
      56,    18,    17,     0,     0,     0,     0,     0,    49,    34,
       0,     0,     0,    16,     0,     0,     6,    10,     9,     8,
       7,    13,    20,    24,    25,     0,    26,     0,    27,    28,
      31,    32,    29,    30,     0,    33,     0,    56,    55,     0,
       0,     0,    73,    71,    72,    52,    56,    53,     0,    39,
      38,     0,     0,    48,     0,    51,    50,    15,    19,     0,
      11,    21,     0,     0,    42,     0,    23,     0,     0,     0,
       0,    74,    75,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    54,    40,     0,     0,    12,    22,
      36,    45,     0,     0,    44,    35,    37,     0,    70,    59,
      61,    60,    62,    63,    64,    65,    66,    69,    68,    67,
       0,     0,    41,    43,    58,     0,    57,    46,     0,    47
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,     6,    26,     7,    27,    28,    29,    30,    31,
      32,    74,    34,    35,    36,    75,    76,   103,    38,    39,
      40,    41,    42,    43,    59,    52,    53,    45,    54,    55
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -56
static const yytype_int16 yypact[] =
{
     -56,    14,   -56,   -15,   -56,   -56,    -9,    93,   -56,   -56,
      -5,   -56,   -56,    -1,    19,    -3,    -1,    19,    19,   -56,
      20,    19,    -1,   -56,    21,    23,   -56,     0,   -56,   -56,
     -56,   -56,     2,   -18,   -56,    -2,   -56,   179,   -56,   -56,
     -56,   -56,   -56,   -56,    16,   -56,    -1,    12,   -56,    -1,
      -1,    -1,   -56,   -56,   -56,   225,   -56,   -56,    55,   -56,
     -56,   109,    31,   -56,    36,   -56,   225,   -56,   -56,   146,
     -56,   -56,   179,    -1,    -7,   179,   -56,    -1,   188,    -1,
     201,   -56,   -56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   -56,   -56,    -1,    60,   -56,   -56,
     225,   -56,   179,   179,   -56,   225,   -56,   214,   -56,    17,
      17,    17,    49,    49,   -27,   -27,   -27,   -56,   -56,   -56,
     142,    38,   -56,   -56,   -56,    -1,   -56,   175,    -1,   225
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -56,   -56,   -56,   -56,   -56,   -56,   -56,   -56,   -23,    24,
      -6,     9,   -56,   -56,   -56,    10,   -55,   -56,   -56,   -56,
     -56,   -56,   -56,   -56,   -56,    74,    22,   -56,   -56,   -16
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      61,    48,    47,    48,    70,    11,    66,    11,   101,    71,
      91,    92,    93,     8,     2,     3,    33,    37,     4,     9,
     104,    46,    56,    64,    67,    49,    72,    73,    68,    44,
      78,    58,    50,    80,    81,    82,    57,   102,    79,    62,
      63,    51,     5,    65,    69,    77,    25,   122,   123,    86,
      87,    88,    89,    90,    91,    92,    93,   100,    94,    44,
      96,   105,    97,   107,   121,   126,    99,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    33,    37,
     120,    33,    37,    88,    89,    90,    91,    92,    93,    60,
       0,    44,     0,    98,    44,     0,    10,    44,    11,     0,
       0,    12,    13,    14,    15,     0,    16,     0,     0,   127,
      17,     0,   129,    18,    19,    20,    21,    22,    23,     0,
       0,     0,     0,    95,    44,    44,     0,    24,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    25,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    10,
       0,    68,     0,     0,     0,    13,    14,    15,     0,    16,
     125,     0,     0,    17,     0,     0,    18,    19,    20,    21,
      22,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    10,     0,     0,     0,     0,     0,    13,    14,
      15,     0,    16,     0,   128,     0,    17,     0,     0,    18,
      19,    20,    21,    22,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,   106,     0,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,   108,     0,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,   124,     0,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-56))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
      16,     4,     3,     4,    27,     5,    22,     5,    15,    32,
      37,    38,    39,    28,     0,     1,     7,     7,     4,    28,
      75,    26,     3,     3,     3,    26,    44,    29,     5,     7,
      46,    34,    33,    49,    50,    51,    14,    44,    26,    17,
      18,    42,    28,    21,    44,    29,    44,   102,   103,    32,
      33,    34,    35,    36,    37,    38,    39,    73,     3,    37,
      29,    77,    26,    79,     4,    27,    72,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    69,    69,
      96,    72,    72,    34,    35,    36,    37,    38,    39,    15,
      -1,    69,    -1,    69,    72,    -1,     3,    75,     5,    -1,
      -1,     8,     9,    10,    11,    -1,    13,    -1,    -1,   125,
      17,    -1,   128,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    14,   102,   103,    -1,    34,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,     3,
      -1,     5,    -1,    -1,    -1,     9,    10,    11,    -1,    13,
      18,    -1,    -1,    17,    -1,    -1,    20,    21,    22,    23,
      24,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,     3,    -1,    -1,    -1,    -1,    -1,     9,    10,
      11,    -1,    13,    -1,    19,    -1,    17,    -1,    -1,    20,
      21,    22,    23,    24,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    27,    -1,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    27,    -1,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    27,    -1,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    46,     0,     1,     4,    28,    47,    49,    28,    28,
       3,     5,     8,     9,    10,    11,    13,    17,    20,    21,
      22,    23,    24,    25,    34,    44,    48,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    63,    64,
      65,    66,    67,    68,    71,    72,    26,     3,     4,    26,
      33,    42,    70,    71,    73,    74,     3,    71,    34,    69,
      70,    74,    71,    71,     3,    71,    74,     3,     5,    44,
      53,    53,    44,    29,    56,    60,    61,    29,    74,    26,
      74,    74,    74,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,     3,    14,    29,    26,    54,    55,
      74,    15,    44,    62,    61,    74,    27,    74,    27,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,     4,    61,    61,    27,    18,    27,    74,    19,    74
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:

/* Line 1806 of yacc.c  */
#line 154 "tinybas.y"
    { initnode(); }
    break;

  case 4:

/* Line 1806 of yacc.c  */
#line 155 "tinybas.y"
    { gencode((yyvsp[(2) - (3)])); initnode(); }
    break;

  case 5:

/* Line 1806 of yacc.c  */
#line 156 "tinybas.y"
    { yyerrok; initnode(); printf(" in %d\n",cur_ln); }
    break;

  case 6:

/* Line 1806 of yacc.c  */
#line 158 "tinybas.y"
    { (yyval) = mknd(':' , (yyvsp[(1) - (2)]) , (yyvsp[(2) - (2)]) ); }
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 160 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 161 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 162 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 163 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 164 "tinybas.y"
    { (yyval) = mknd(':' , (yyvsp[(1) - (2)]) , (yyvsp[(2) - (2)])); }
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 165 "tinybas.y"
    { (yyval) = mknd(':' , (yyvsp[(1) - (3)]) , (yyvsp[(3) - (3)])); }
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 166 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 168 "tinybas.y"
    { (yyval) = mknd(LINENUMBER , 0 , 0); mk_line((yyvsp[(1) - (1)])); }
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 170 "tinybas.y"
    { (yyval) = mknd(LABEL , (yyvsp[(2) - (2)]) , 0); mk_lbl((yyvsp[(2) - (2)])); }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 172 "tinybas.y"
    { (yyval) = mknd(PRINTX , 0 , 0 ); printx(); }
    break;

  case 17:

/* Line 1806 of yacc.c  */
#line 174 "tinybas.y"
    { (yyval) = mknd(INLINE , 0 , 0 ); inline_(); }
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 176 "tinybas.y"
    { (yyval) = mknd(REM , 0 , 0 ); rem(); }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 177 "tinybas.y"
    { (yyval) = mknd(REM , 0 , 0 ); rem(); }
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 179 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 180 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (2)]); }
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 182 "tinybas.y"
    { (yyval) = mknd(':' , (yyvsp[(1) - (3)]) , (yyvsp[(3) - (3)])); }
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 183 "tinybas.y"
    { (yyval) = mknd(':',mknd(':',(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)])),mknd(ENDIF,0,0)); }
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 184 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 186 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 187 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 188 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 189 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 190 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 191 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 192 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 193 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 194 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 195 "tinybas.y"
    { (yyval) = mknd(END , 0 , 0 ); }
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 197 "tinybas.y"
    { (yyval) = mknd('L', (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 198 "tinybas.y"
    { (yyval) = mknd('R', (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 200 "tinybas.y"
    { (yyval) = mknd('D', (yyvsp[(1) - (4)]), (yyvsp[(3) - (4)])); }
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 202 "tinybas.y"
    { (yyval) = mknd(GOTO, (yyvsp[(2) - (2)]), 0); }
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 203 "tinybas.y"
    { (yyval) = mknd(GOLBL, (yyvsp[(2) - (2)]), 0); }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 205 "tinybas.y"
    { (yyval) = mknd(IF,(yyvsp[(2) - (3)]),0); }
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 207 "tinybas.y"
    { (yyval) = mknd(':' , (yyvsp[(1) - (3)]) , (yyvsp[(3) - (3)])); }
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 208 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 209 "tinybas.y"
    { (yyval) = mknd(':' , mknd(':' , (yyvsp[(1) - (3)]) , (yyvsp[(2) - (3)])) , (yyvsp[(3) - (3)])); }
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 210 "tinybas.y"
    { (yyval) = mknd(':' , (yyvsp[(1) - (2)]) , (yyvsp[(2) - (2)])); }
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 212 "tinybas.y"
    { (yyval) = mknd(ELSE,0,0); }
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 215 "tinybas.y"
    { (yyval) = mknd(FOR,(yyvsp[(2) - (6)]),mknd(TO,(yyvsp[(4) - (6)]),mknd(STEP,(yyvsp[(6) - (6)]),-1))); }
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 217 "tinybas.y"
    { (yyval) = mknd(FOR,(yyvsp[(2) - (8)]),mknd(TO,(yyvsp[(4) - (8)]),mknd(STEP,(yyvsp[(6) - (8)]),(yyvsp[(8) - (8)])))); }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 219 "tinybas.y"
    { (yyval) = mknd(NEXT,(yyvsp[(2) - (2)]),0); }
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 220 "tinybas.y"
    { (yyval) = mknd(NEXT,-1,0); }
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 222 "tinybas.y"
    { (yyval) = mknd(PRINT,(yyvsp[(2) - (2)]),0); }
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 224 "tinybas.y"
    { (yyval) = mknd(INPUT,(yyvsp[(2) - (2)]),0); }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 226 "tinybas.y"
    { (yyval) = mknd(INLINE_PUSH,(yyvsp[(2) - (2)]),0); }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 228 "tinybas.y"
    { (yyval) = mknd(INLINE_POP,(yyvsp[(2) - (2)]),0); }
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 230 "tinybas.y"
    { (yyval) = mknd('l', (yyvsp[(2) - (2)]), 0); }
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 232 "tinybas.y"
    { (yyval) = mknd('C', (yyvsp[(1) - (1)]), 0); }
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 234 "tinybas.y"
    { (yyval) = mknd('V', mk_var((yyvsp[(1) - (1)])), 0); }
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 237 "tinybas.y"
    { (yyval) = mknd(DIM , (yyvsp[(2) - (5)]) , (yyvsp[(4) - (5)]) ); }
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 239 "tinybas.y"
    { (yyval) = mknd('A', (yyvsp[(1) - (4)]), (yyvsp[(3) - (4)])); }
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 241 "tinybas.y"
    { (yyval) = mknd('=', (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 242 "tinybas.y"
    { (yyval) = mknd('>', (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 243 "tinybas.y"
    { (yyval) = mknd('<', (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 244 "tinybas.y"
    { (yyval) = mknd('+', (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 245 "tinybas.y"
    { (yyval) = mknd('-', (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 246 "tinybas.y"
    { (yyval) = mknd('*', (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 247 "tinybas.y"
    { (yyval) = mknd('/', (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 248 "tinybas.y"
    { (yyval) = mknd(MOD, (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 249 "tinybas.y"
    { (yyval) = mknd(AND, (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 250 "tinybas.y"
    { (yyval) = mknd(OR , (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 251 "tinybas.y"
    { (yyval) = mknd(XOR, (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 252 "tinybas.y"
    { (yyval) = (yyvsp[(2) - (3)]); }
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 253 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 254 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 255 "tinybas.y"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 256 "tinybas.y"
    { (yyval) = mknd(NEG, (yyvsp[(2) - (2)]), 0); }
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 257 "tinybas.y"
    { (yyval) = mknd(NOT, (yyvsp[(2) - (2)]), 0); }
    break;



/* Line 1806 of yacc.c  */
#line 2161 "tinybas.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 259 "tinybas.y"


/*********************************************************
**		compiler lexer
**********************************************************/
int yylex()
{
	int c,i;
	char id[100];
	int  v,y;

  while(1) {
	while (((c=yygetc()) == ' ')||(c == '\t'));
	if (isdigit(c)) {
		/* decimal constant */
		yyungetc(c);
		fscanf(infile,"%d", &i);
		yylval = i;
		return  NUMBER;
	} else if (c=='\'') {
		fgets(remark,LINE_LEN-1,infile); yyungetc('\n', infile);
		return REM;
	} else if (c=='&') {
		/* hexadecimal constant */
		c=yygetc();
		if ((c!='h')&&(c!='H')) {
			if (isdigit(c)||((c>='a')&&(c<='f'))||((c>='A')&&(c<='F'))) {
				yyungetc(c);
			} else {
				return '&';
			}
		}
		i=0;
		while(1){
			c=yygetc();
			if (isdigit(c)||((c>='a')&&(c<='f'))||((c>='A')&&(c<='F'))) {
				if (isdigit(c)) {
					i=(i<<4)&0xFFFFFFFF;
					i|=c-'0';
				} else {
					i=(i<<4)&0xFFFFFFFF;
					i|=toupper(c)-'A'+10;
				}
			} else {
				yyungetc(c);
				break;
			}
		}
		yylval = i;
		return  NUMBER;
	} else if (isalpha(c)) {
		v=0;
		while (isalpha(c)||isdigit(c)||(c=='_')) { id[v++]=c; c=yygetc(); }
		yyungetc(c);
		id[v]='\0';
		/* remark , inline , printx */
		if (my_stricmp(id,"REM")==0) {
			fgets(remark,LINE_LEN-1,infile); yyungetc('\n'); return REM;
		}
		if (my_stricmp(id,"INLINE")==0) {
			fgets(inlines,LINE_LEN-1,infile); yyungetc('\n'); return INLINE;
		}
		if (my_stricmp(id,"PRINTX")==0) {
			fgets(prt_str,LINE_LEN-1,infile); yyungetc('\n'); return PRINTX;
		}
		/* operator , built-in command */
		if (my_stricmp(id,"MOD")==0) { return MOD; }
		if (my_stricmp(id,"AND")==0) { return AND; }
		if (my_stricmp(id,"OR" )==0) { return OR;  }
		if (my_stricmp(id,"XOR")==0) { return XOR; }
		if (my_stricmp(id,"NOT")==0) { return NOT; }
		if (my_stricmp(id,"GOTO")==0)	{ return GOTO; }
		if (my_stricmp(id,"IF")==0)	{ return IF; }
		if (my_stricmp(id,"THEN")==0)	{ return THEN; }
		if (my_stricmp(id,"ELSE")==0)	{ return ELSE; }
		if (my_stricmp(id,"FOR")==0)	{ return FOR; }
		if (my_stricmp(id,"TO")==0)	{ return TO; }
		if (my_stricmp(id,"STEP")==0)	{ return STEP; }
		if (my_stricmp(id,"NEXT")==0)	{ return NEXT; }
		if (my_stricmp(id,"END")==0)	{ return END; }
		if (my_stricmp(id,"DIM")==0)	{ return DIM; }
		if (my_stricmp(id,"INPUT")==0)	{ return INPUT; }
		if (my_stricmp(id,"PRINT")==0)	{ return PRINT; }
		if (my_stricmp(id,"IL_PUSH")==0)	{ return INLINE_PUSH; }
		if (my_stricmp(id,"IL_POP")==0)	{ return INLINE_POP; }
		/* other */
		y=id_exist(id);
		if ( y==-1 ) {
			y=create_id(id);
			yylval = y;
		} else {
			yylval = y;
		}
		return ID;
	} else {
		return  c;
	}
  }
}

int yygetc() { return getc(infile); }
int yyungetc(int c) { ungetc(c,infile); return 0; }
int yyerror(char *s) { fputs(s, stdout); error_flag=1; return 0; }

/*********************************************
**		compiler code generate
**********************************************/
void	gencode(int p)
{
	int l = node[p].left, r = node[p].right;
	int f1,f2,f3,f4,f5,f6,f7;
	
	switch (node[p].op) {
	case ':': gencode(l); gencode(r); return;							/* multi statement */
	case 'C': print("\tldc.i4\t%d\n",l); return;						/* constant */
	case 'V': print("\tldloc\t_V%d\n",l); return;						/* var */
	case 'L': gencode(r); print("\tstloc\t_V%d\n", val(l) ); return;	/* store to var */
	case DIM: mk_array(val(l),r); return;								/* define array  */
	case 'A': print("\tldloc\t_A%d\n",l); gencode(r); print("\tldelem.i4\n"); return;	/* array */
	case 'R': gencode(l); gencode(r); print("\tstelem.i4\n"); return;	/* store to array */
	case 'D': print("\tldloc\t_A%d\n",l); gencode(r); return;			/* store to array */
	case NEG: gencode(l); print("\tneg\n"); return;						/* op negate */
	case NOT: gencode(l); print("\tnot\n"); return;						/* op not */
	case '+': gencode(l); gencode(r); print("\tadd\n"); return;			/* op add */
	case '-': gencode(l); gencode(r); print("\tsub\n"); return;			/* op sub */
	case '*': gencode(l); gencode(r); print("\tmul\n"); return;			/* op mul */
	case '/': gencode(l); gencode(r); print("\tdiv\n"); return;			/* op div */
	case MOD: gencode(l); gencode(r); print("\trem\n"); return;			/* op mid */
	case AND: gencode(l); gencode(r); print("\tand\n"); return;			/* op and */
	case OR:  gencode(l); gencode(r); print("\tor\n");  return;			/* op or  */
	case XOR: gencode(l); gencode(r); print("\txor\n"); return;			/* op xor */
	case '=': gencode(l); gencode(r); print("\tceq\n"); return;			/* compare(=) */
	case '<': gencode(l); gencode(r); print("\tclt\n"); return;			/* compare(<) */
	case '>': gencode(l); gencode(r); print("\tcgt\n"); return;			/* compare(>) */
	case LINENUMBER: return;	/* line number (dummy) */
	case LABEL: return;			/* label(dummy) */
	case REM: return;			/* remark(dummy) */
	case INLINE: return;		/* inline(dummy) */
	case PRINTX: return;		/* printx(dummy) */
	case GOTO: mk_goto( val(l) ); return;		/* goto */
	case GOLBL: mk_goto_lbl( val(l) ); return;		/* goto label */
	case IF: mk_if_then(l); return;	/* if then */
	case ELSE: mk_else(); return;	/* else */
	case ENDIF: mk_endif(); return;	/* endif */
	case FOR:	/*  FOR */
		f1=l; f2=node[r].op; f3=node[r].left; f4=node[r].right;
		if (f2==TO) {
			f5=node[f4].op; f6=node[f4].left; f7=node[f4].right;
			if (f5==STEP) { /* for f1=f3 to f6 step f7 */
				mk_for(f1,f3,f6,f7);
			} else {
				printf("Error: 'STEP' Error in %d\n",cur_ln); error_flag=1;
			}
		} else {
				printf("Error: 'TO' Error in %d\n",cur_ln); error_flag=1;
		}
		return;
	case NEXT: mk_next(l); return;	/* next */
	case PRINT:	/* print */
		gencode(l);
		print("\tcall void [mscorlib]System.Console::WriteLine(int32)\n");
		return;
	case INPUT:	/* input */
		print("\tldstr\t\"?\"\n");
		print("\tcall void [mscorlib]System.Console::Write(string)\n");
		print("\tcall string [mscorlib]System.Console::ReadLine()\n");
		print("\tldloca\t_V%d\n", val(l) );
		print("\tcall bool [mscorlib]System.Int32::TryParse(string,int32&)\n");
		print("\tpop\n");
		return;
	case INLINE_PUSH: gencode(l); return;	/* inline_push */
	case INLINE_POP: print("\tstloc\t_V%d\n", val(l) ); return;	/* inline_pop */
	case END: mk_end(); return;	/* end */
	}
}

/*********************************************************
**		Subroutines
**********************************************************/
void rem() /* REM */
{
	print("//\tREM %s",remark);
}
void inline_() /* INLINE */
{
	print("//\tINLINE\n\t%s",inlines);
}
void printx() /* PRINTX */
{
	print("\tldstr %s",prt_str);
	print("\tcall void [mscorlib]System.Console::WriteLine(string)\n");
}

void mk_end() /* END */
{
	print("\tbr\t_END\n");
}

void mk_goto(int p) /* GOTO */
{
	print("\t//GOTO\n"); print("\tbr\t_L%d\n",ref_line(p));
}
void mk_goto_lbl(int p) /* GOTO label */
{
	print("\t//GOTO\n"); print("\tbr\tLBL%d\n",ref_lbl(p));
}

void mk_if_then(int p) /* IF,THEN */
{
	int ilbl;
	ilbl=if_total;
	if_stack[if_stackp++]=if_total;
	if_stack2[if_stackp2++]=if_total;
	if_total++;
	print("\t//IF\n");
	gencode(p);
	print("\tbrtrue\t_IL%d_THEN\n",ilbl); /* if --true-- then goto label */
	print("\tbr\t_IL%d_ELSE\n",ilbl);
	print("_IL%d_THEN:\n",ilbl);
	return;
}
void mk_else() /* ELSE */
{
	int ilbl;
	if (if_stackp==0) {
		ilbl=0; printf("Error: ELSE without IF.  in %d\n",cur_ln); error_flag=1;
	} else {
		ilbl=if_stack[--if_stackp];
	}
	print("\tbr\t_IL%d_ENDIF\n",ilbl);
	print("_IL%d_ELSE:\n",ilbl);
	return;
}
void mk_endif() /* ENDIF */
{
	int i,j,ilbl,flag;
	if (if_stackp2==0) {
		printf("Error: ENDIF without IF.  in %d\n",cur_ln); error_flag=1;
	}
	for (i=0;i<if_stackp2;i++) {
		ilbl=if_stack2[i];
		if (if_stackp==0) {
			print("_IL%d_ENDIF:\n",ilbl);
		} else {
			flag=0;
			for (j=0;j<if_stackp;j++) {
				if (if_stack[j]==ilbl) flag=1;
			}
			if (flag==0) {
				print("_IL%d_ENDIF:\n",ilbl);
			} else {
				print("_IL%d_ELSE:\n",ilbl);
				print("_IL%d_ENDIF:\n",ilbl);
			}
		}
	}
	return;
}

void mk_for(int f1,int f2,int f3,int f4) /* FOR */
{
	int step,flbl;
	if (f4==-1) {
		step=1; /* no STEP */
	} else {
		if (node[f4].op=='C') {
			step=node[f4].left;
		} else {
			step=1; printf("FOR's STEP must be constant. in %d\n",cur_ln);
		}
	}
	if (step==0) {
		step=1; printf("STEP should not be zero.\n");
	}
	/*   var = f1     */
	print("\t//FOR\n");
	if (node[f1].op == 'V') {
		gencode(f2);
	}
	print("\tldc.i4\t%d\n",step);
	print("\tsub\n");
	print("\tstloc\t_V%d\n", val(f1) );
	flbl=for_total;
	for_stack[for_stackp++]=for_total;
	for_var[for_total]=val(f1);
	for_line[for_total]=cur_ln;
	for_total++;
	print("_FL%d:\n",flbl);
	print("\tldloc\t_V%d\n",val(f1));
	print("\tldc.i4\t%d\n",step);
	print("\tadd\n");
	print("\tdup\n");
	print("\tstloc\t_V%d\n", val(f1) );
	gencode(f3);
	if (step>0) {
		print("\tbgt\t_FL%d_END\n",flbl);
	} else if (step<0) {
		print("\tblt\t_FL%d_END\n",flbl);
	}
	return;
}
void mk_next(int p) /* NEXT */
{
	int flbl,fvar,fl;
	if (for_stackp==0) {
		flbl=99999; printf("Error: NEXT without FOR.  in %d\n",cur_ln); error_flag=1;
	} else {
		flbl=for_stack[--for_stackp];
	}
	fvar=for_var[flbl]; fl=for_line[flbl];
	if (p==-1) { /* NEXT without var */
		print("\tbr\t_FL%d\n",flbl);
		print("\t//NEXT\n");
		print("_FL%d_END:\n",flbl);
	} else { /* NEXT with var */
		if (val(p)!=fvar) {
			printf("Error: FOR and NEXT variable doesn't match in %d,%d\n",fl,cur_ln); error_flag=1;
		}
		print("\tbr\t_FL%d\n",flbl);
		print("\t//NEXT\n");
		print("_FL%d_END:\n",flbl);
	}
	return;
}

void initnode() /* init tree */
{
	nodeptr = 0; if_stackp = 0; if_stackp2 = 0;
}

int mknd(int op, int l, int r) /* make node of tree */
{
	if ((op==NEG)&&(node[l].op=='C')) {	  /* negate op + const */
		node[l].left = -val(l); return l;
	}
	node[nodeptr].op = op; node[nodeptr].left = l; node[nodeptr].right = r;
	return  nodeptr++;
}

int create_id(char *id_name) /* identifier */
{
	strcpy( identifier[id_total], id_name ); id_total++;
	return id_total-1;
}
int id_exist(char *id_name)
{
	int	i;
	if (id_total==0) return -1;
	for (i=0;i<id_total;i++) {
		if ( my_stricmp(identifier[i],id_name )==0 ) { return i; }
	}
	return -1;
}

int mk_var(int p) /* integer variable */
{
	int i,id_nm=p;
	if ((i=var_exist(id_nm))==-1) {
		i=create_var(id_nm); print("\t.locals ( int32 _V%d )\n",i);
	}
	return i;
}
int create_var(int id_nm)
{
	strcpy( var_id[var_total], identifier[id_nm] ); var_total++;
	return var_total-1;
}
int var_exist(int id_nm)
{
	int	i;
	if (var_total==0) { return -1; }
	for (i=0;i<var_total;i++) {
		if ( my_stricmp(var_id[i], identifier[id_nm] )==0 ) { return i; }
	}
	return -1;
}

int mk_array(int p , int size) /* integer array */
{
	int i,id_nm=(int)p;
	if ((i=array_exist(id_nm))==-1) {
		i=create_array(id_nm);
		print("\t.locals ( int32[] _A%d )\n",i);
		print("\tldc.i4\t%d\n",size+1);
		print("\tnewarr\tint32\n");
		print("\tstloc\t_A%d\n",i);
	}
	return i;
}
int create_array(int id_nm)
{
	strcpy( array_id[array_total], identifier[id_nm] ); array_total++;
	return array_total-1;
}
int array_exist(int id_nm)
{
	int	i;
	if (array_total==0) { return -1; }
	for (i=0;i<array_total;i++) {
		if ( my_stricmp(array_id[i], identifier[id_nm] )==0 ) { return i; }
	}
	return -1;
}

int mk_lbl(int p) /* label */
{
	int	i,id_nm=p;
	if ((i=lbl_exist(id_nm))==-1) {
		i=create_lbl(id_nm); lbl_flag[i]=0x01; print("\tLBL%d:\n",i);
		return i;
	} else {
		if ( (lbl_flag[i] == 0x01) || (lbl_flag[i] == 0x03) ) {
			print("\tLBL%d:\n",i);
			printf("error: Duplicate Label %s\n",lbl_id[i]);
		} else {
			lbl_flag[i]+=0x01; print("\tLBL%d:\n",i);
		}
		return i;
	}
}
int ref_lbl(int p)
{
	int	i,id_nm=p;
	if ((i=lbl_exist(id_nm))==-1) {
		i=create_lbl(id_nm);
		lbl_flag[i]=0x02;	/*   referenced flag   */
	} else {
		lbl_flag[i]|=0x02;	/*   referenced flag   */
	}
	lbl_access[lbl_acs][0]=i; lbl_access[lbl_acs][1]=cur_ln; lbl_acs++;
	return i;
}
int	create_lbl(int id_nm)
{
	strcpy( lbl_id[lbl_total], identifier[id_nm] ); lbl_total++;
	return lbl_total-1;
}
int lbl_exist(int id_nm)
{
	int	i;
	if (lbl_total==0) { return -1; }
	for (i=0;i<lbl_total;i++) {
		if ( my_stricmp(lbl_id[i], identifier[id_nm] )==0 ) { return i; }
	}
	return -1;
}

void mk_line(int p) /* line number */
{
	int ll;
	int line=p;
	if ( cur_ln < prv_ln ) {
		printf("warning: Line %d < %d \n",cur_ln,prv_ln);
	} else {
		prv_ln=cur_ln;
	}
	cur_ln=line; rdln++;
	if ( (ll=line_exist(line))<0 ) {
		ll=create_line(line); line_flag[ll]=0x01; print("\n_L%d:\n",cur_ln);
	} else {
		if ( (line_flag[ll] == 0x01) || (line_flag[ll] == 0x03) ) {
			print("\n_L%d:\n",cur_ln);
			printf("error: Dupulicate Line %d\n",line);
		} else {
			line_flag[ll]+=0x01; print("\n_L%d:\n",cur_ln);
		}
	}
}
int ref_line(int line)
{
	int l;
	if ( (l=line_exist(line))<0 ) {
		l=create_line(line); line_flag[l]=0x02;
	} else {
		line_flag[l]|=0x02;
	}
	line_access[line_acs][0]=l; line_access[line_acs][1]=cur_ln; line_acs++;
	return line;
}
int create_line(int line)
{
	line_num[line_total]=line; line_total++;
	return line_total-1;
}
int line_exist(int line)
{
	int i;
	if (line_total==0) { return -1; }
	for (i=0;i<line_total;i++) {
		if ( line_num[i]==line ) { return i; }
	}
	return -1;
}

int my_stricmp(char *s1,char *s2)
{
	char c1,c2;
	while (1) {
		c1=*s1++; c2=*s2++; c1=tolower(c1); c2=tolower(c2);
		if ((c1=='\0')||(c2=='\0')||(c1!=c2)) { break; }
	}
	return (int) c1-c2;
}

